<?xml version="1.0" encoding="ISO-8859-1" ?><!--*- sgml; tab-width: 2 -*-->
<xsl:stylesheet version="1.0"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:import href="html.xsl" />

	<xsl:template name="newfile">
		<xsl:param name="filename" />
		<xsl:param name="type" />
		<xsl:param name="title" />

		<xsl:document href="{$filename}.html">
			<html>
				<head>
					<title><xsl:value-of select="$title"/></title>
					<link rel="stylesheet" type="text/css" href="style.css" />
				</head>
				<body bgcolor="#eaba00">
					<table borer="0" cellspacing="0" cellpadding="0" width="100%" bgcolor="black">
						<tr>
							<td width="107">
								<img src="images/LuaCheiaLogo2.gif"
									 title="LuaCheia Logo"
									 alt="LuaCheia Logo"
									 width="107"
									 height="80" />
							</td>
							<td width="20"><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text></td>
							<td colspan="2" width="*" class="text">
								<h1 id="title"><font color="#eaba00">LuaCheia Reference Manual</font></h1>
							</td>
						</tr>
					</table>
					<table cellspacing="10" cellpadding="0" width="100%">
						<tr>
							<td colspan="2" valign="top" width="70%">
							  <table class="shadow" cellspacing="0" cellpadding="10" width="100%" bgcolor="white"><tr><td>
									<xsl:if test="$type = 'top'">
										<h1><xsl:apply-templates select="document" mode="read" /></h1>
									</xsl:if>
									<xsl:apply-templates />
								</td></tr></table>
							</td>
							<td valign="top" width="30%">
							  <table class="shadow" cellspacing="0" cellpadding="10" width="100%" bgcolor="white"><tr><td>
								<p><a href="../">Return to main site</a></p>
								<xsl:for-each select="//xfile">
									<xsl:choose>
										<xsl:when test="part">
											<h3><xsl:apply-templates select="part/node()" /></h3>
										</xsl:when>
										<xsl:when test="chapter|module|appendix">
											<xsl:variable name="filename" select="((chapter|module|appendix)/@id)|((chapter|module|appendix)[not(@id)]/text())" />
											<xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;raquo;&amp;nbsp;</xsl:text>
											<a href="{$filename}.html"><xsl:apply-templates select="(chapter|module|appendix)/node()" /></a><br />
										</xsl:when>
									</xsl:choose>
								</xsl:for-each>
								</td></tr></table>
							</td>
						</tr>
					</table>
				</body>
			</html>
		</xsl:document>
		<xsl:if test="$toc != ''">
			<xsl:if test="not(preceding-sibling::node()[1][self::xfile[chapter|module|appendix]])">
				<xsl:text disable-output-escaping="yes">&lt;ul class="toc"></xsl:text>
			</xsl:if>
			<li class="toc"><a href="{$filename}.html"><xsl:value-of select="$toc"/></a></li>
			<xsl:if test="not(following-sibling::node()[1][self::xfile[chapter|module|appendix]])">
				<xsl:text disable-output-escaping="yes">&lt;/ul></xsl:text>
			</xsl:if>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
