#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

extern int yylineno;

// Die with a message
void die(const char *msg, ...)
{
	va_list ap;
	va_start(ap,msg);
	fprintf(stderr,"x2xml: ");
	vfprintf(stderr,msg,ap);
	fprintf(stderr," at line %d.\n",yylineno);
	va_end(ap);
	exit(1);
}

// Print a warning
void warn(const char *msg, ...)
{
	va_list ap;
	va_start(ap,msg);
	fprintf(stderr,"x2xml: Warning: ");
	vfprintf(stderr,msg,ap);
	fprintf(stderr," at line %d.\n",yylineno);
	va_end(ap);
}
