-- Excerpted from the luacom manual; demonstrates the luacom module on Win32

assert(cheia.load("luacom"))

-- Creates and fills the Lua table that will implement the
-- ActiveX interface

events_table = {}

function events_table:AfterUpdate()
  print("AfterUpdate called!")
end

-- Here we implement the interface DCalendarEvents, which is part
-- of the Microsoft(R) Calendar object, whose ProgID is MSCAL.Calendar

events_obj = luacom.ImplInterface(
  events_table, 
  "MSCAL.Calendar",
  "DCalendarEvents")

-- Checks for errors
--
if events_obj == nil then
  print("Implementation failed")
  os.exit(1)
end

-- Tests the interface: this must generate a call to the events:AfterUpdate
-- defined above
--
events_obj:AfterUpdate()