/* ============================================================================
*
 * gusu.h: Angus' UNIX lib for windows
 *
 * Copyright (C) 1997-2000 Angus Mackay. All rights reserved; 
 *
 * This code is free; you may do with it as you will.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * ============================================================================
 */
/* hacked up for luacheia by tulrich */


#include <sys/timeb.h>
#include <time.h>

/* for struct timeval */
#include <winsock.h>

#include <sys/stat.h>

#ifndef DLLEXP
#  define DLLEXP __declspec(dllexport)
#endif
#ifndef DLLIMP
#  define DLLIMP __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if 0
struct timeval
{
  time_t tv_sec;              /* Seconds.  */
  time_t tv_usec;             /* Microseconds.  */
};
#endif

typedef struct
{
  HANDLE h;
  int state;
  char *dirname;
} DIR;

struct dirent
{
  long d_ino;                 /* inode number */
  long d_off;                 /* offset to this dirent */
  unsigned short d_reclen;    /* length of this d_name */
  char d_name[MAX_PATH];   /* file name (null-terminated) */
};

struct tms
{
    clock_t tms_utime;          /* User CPU time.  */
    clock_t tms_stime;          /* not implemented */
    clock_t tms_cutime;         /* not implemented */
    clock_t tms_cstime;         /* not implemented */
};

///* Test macros for file types.  */
//#define __S_ISTYPE(mode, mask)  (((mode) & _S_IFMT) == (mask)) 
//   
//#define S_ISDIR(mode)   __S_ISTYPE((mode), _S_IFDIR)
//#define S_ISCHR(mode)   __S_ISTYPE((mode), _S_IFCHR)
//#define S_ISREG(mode)   __S_ISTYPE((mode), _S_IFREG) 
//#ifdef _S_IFBLK 
//#define S_ISBLK(mode)   __S_ISTYPE((mode), _S_IFBLK)
//#endif
//
//#ifdef _S_IFIFO 
//#define S_ISFIFO(mode)  __S_ISTYPE((mode), _S_IFIFO)
//#endif

/*
 * emulated with _ftime()
 * currently the time timezone is ignored
 */
struct timezone {};
extern int gusu_gettimeofday(struct timeval *tv, struct timezone *tz);

/*
 * emulated with millisecond percision Sleep()
 */
extern void gusu_usleep(unsigned long usec);

/*
 * emulated with millisecond percision Sleep()
 */
extern unsigned int gusu_sleep(unsigned int seconds);

/*
 * emulated with FindFirstFile() and friends
 */
extern DIR     *gusu_opendir(const char *);
extern struct dirent *gusu_readdir(DIR *);
extern int     gusu_closedir(DIR *);
/* extern void    gusu_rewinddir(DIR *); */

/*
 * emulated with clock()
 */
extern clock_t gusu_times(struct tms *t);

#ifdef __cplusplus
}
#endif

