/*---
 * Loadlib functions:
 *
 * This header is only needed by external dynamic linkage packages (s.a. gluax)
 * that need C-level access to the portability functions of 'loadlib.c'.
 *
 * This could be merged into 'lualib.h'.
 */
#ifndef LOADLIB_H
#define LOADLIB_H

#include <stddef.h>  /* size_t */

typedef void* h_LoadLib;

/* If you want to expose the loadlib_open() and other functions, then
 * do something like -DLOADLIB_API=LUALIB_API 
 * Otherwise those API's are not exposed. */
#ifndef LOADLIB_API
#define LOADLIB_API static
#endif

LOADLIB_API h_LoadLib loadlib_open( const char* path );
LOADLIB_API void loadlib_close( h_LoadLib handle );
LOADLIB_API void* loadlib_func( h_LoadLib handle, const char* name );
LOADLIB_API const char* loadlib_error( char* buf, size_t bufsize );

#endif  /* LOADLIB_H */
