-- Modified for LuaCheia.

-- -- md5.lua
-- -- support code for md5 library
-- -- usage lua -lmd5 ...
-- 
-- local function so(x)
-- 	local SOPATH= os.getenv"LUA_SOPATH" or "./"
-- 	assert(loadlib(SOPATH.."l"..x..".so","luaopen_"..x))()
-- end
-- so"md5"

-- For LuaCheia, use loadmodule.
assert(cheia.loadmodule("md5"))


md5._self_test = function (verbose)
  -- test md5 library
  
  if (verbose) then print(md5.version) end
  
  local KNOWN="6e68025348e32916ca66b6b38b8dda26"
  
  local report = function(w,s,F)
   if (verbose) then print(w,s.."  ") end
   assert(s==KNOWN, w .. " test failed")
  end
  
  -- tulrich: use fixed data instead of an external file.
  local DATA = [[-- md5.lua
-- support code for md5 library
-- usage lua -lmd5 ...

local function so(x)
	local SOPATH= os.getenv"LUA_SOPATH" or "./"
	assert(loadlib(SOPATH.."l"..x..".so","luaopen_"..x))()
end

so"md5"
md5.metatable.__index=md5
md5.metatable.__tostring=md5.tostring
]]
  
  report("all",md5.digest(DATA),F)
  
  local d=md5.new()
  local i
  for i=1,string.len(DATA) do
   local c = string.sub(DATA, i, i)
   d:update(c)
  end
  report("loop",d:digest(),F)
  
  d:reset()
  i = 1
  while true do
   local ct = math.random(1,16)
   local c= string.sub(DATA, i, i + ct - 1) -- io.read()
   i = i + ct
   if c=="" then break end
   d:update(c)
  end
  report("reset",d:digest(),F)
  
  --os.execute("echo -en 'md5sum\t'; md5sum "..F)
  --report("known",KNOWN,F)
  
  if (verbose) then print(md5.version) end
  
  return true
end


return true
