-- module loader for Reuben Thomas' "rex" library, compiled against Henry Spencer's regex lib

assert(cheia.loadmodule("rex"))

-- Utility functions
rex.comp = rex.newPCRE

-- string.find replacement
function rex.find(s, r)
  return rex.comp(r):match(s)
end

-- partial string.gsub replacement
function rex.gsub(s, r, f, n)
  if n == nil then
    return rex.comp(r):gmatch(s, f)
  else
    return rex.comp(r):gmatch(s, f, n)
  end
end


function rex._self_test()
	local start, stop = rex.find("this is a test", "test")
	assert(start == 11 and stop == 14, "rex.find failed")

	local counter = 0
	assert(rex.gsub("bobo bobo bobo something else", "bobo", function () counter = counter + 1 end) == 3, "rex.gsub failed")
	assert(counter == 3, "rex.gsub callback failed")

	return true
end


return true
