-- shelve stub loader

assert(cheia.loadmodule("shelve"))

function shelve._self_test()
	-- Choose a strange name for the test file.
	local tmpname = "__ChEiA_ShElVe_MoDuLe_TeSt_FiLe__"
	if (cheia.platform == "WIN32") then
		-- I don't like this way of getting a temporal file
		tmpname = "c:\\"..tmpname
	else
		tmpname = "/tmp/"..tmpname
	end
	-- Open a shelf, read+write mode.
	local dbf = shelve.open(tmpname)
	if (not dbf) then return false end
	-- Store some values.
	local a = "one"
	local b = "two"
	local c = "three"
	dbf.num = 1234567890	-- a number
	dbf.str = "a string"	-- a string
	dbf.t1	= {}					-- empty table
	dbf.t2	= { s="S" }		-- table with one element
	dbf.t3	= { a,b,c }		-- indexed table, multiple elements
	dbf.nested =					-- nested tables
		{
			level = a,
			nest 	= {
				level = b,
				nest	= {
					level = c,
					nest	= "nothing"
				}
			}
		}

	-- Test now wether our values are properly encoded & decoded.
	assert(type(dbf.num) == "number")
	assert(type(dbf.str) == "string")
	assert(type(dbf.t1)  == "table" )
	assert(type(dbf.t2)  == "table" )
	assert(type(dbf.t3)  == "table" )
	assert(dbf.num == 1234567890)
	assert(dbf.str == "a string")
	assert(dbf.t2.s == "S")
	assert(dbf.t3[1] == a)
	assert(dbf.t3[2] == b)
	assert(dbf.t3[3] == c)
	local t = dbf.nested
	assert(type(t) == "table")
	assert(t.level == a)
	assert(type(t.nest) == "table")
	assert(t.nest.level == b)
	assert(type(t.nest.nest) == "table")
	assert(t.nest.nest.level == c)
	assert(type(t.nest.nest.nest) == "string")
	assert(t.nest.nest.nest == "nothing")
	
	-- force Lua to close the shelf and remove temp file.
	dbf = nil; collectgarbage()
	os.remove(tmpname)
	return true
end

return true
